<template>
  <div class="item">
      <router-link class="item--thumbnail" :to="{ name: 'blog_single', params: { slug: article.slug } }">
          <div class="item--thumbnail--inner">
              <img class="item--thumbnail--inner--image" src="https://via.placeholder.com/360X270">
          </div>
      </router-link>
      <div class="item--details">
        <h2 class="item--details--title">
          <router-link :to="{ name: 'blog_single', params: { slug: article.slug } }">
            {{ article.title }}
          </router-link>
        </h2>
        <div class="item--details--meta">
            {{ `By ${article.author.username}, Date: ${creationDateString}` }}
        </div>
        <div class="item--details--excerpt">
            {{
                article.description
            }}
        </div>
      </div>
  </div>
</template>

<script>
export default {
  name: 'BlogArticleItem',
  props: ['article'],
  computed: {
      creationDateString: function(){
          let date = new Date(this.article.createdAt);
          let monthNames = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Nov', 'Oct', 'Dec'];
          let monthDay = date.getDate();
          let monthName = monthNames[date.getMonth()];
          let year = date.getFullYear();
          return `${monthDay} ${monthName} ${year}`;
      }
  }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
.item {
    display: flex;
    flex-direction: column;
    align-items: stretch;
    justify-content: flex-start;
    border-radius: 5px;
    overflow: hidden;
    box-shadow: 0 0 8px 0 rgba(41, 48, 57, 0.5);
}

.item--thumbnail {
    position: relative;
    display: block;
    width: 100%;
    height: 0;
    padding-top: 75%;
}
.item--thumbnail--inner {
    position: absolute;
    top: 0;
    right: 0;
    bottom: 0;
    left: 0;
}

.item--thumbnail--inner--image {
    display: block;
    width: 100%;
}

.item--details {
    padding: 30px;
    padding-right: 60px;
}

.item--details--title {
    padding: 0;
    margin: 0;
    font-size: 22px;
    line-height: 36px;
    font-weight: bold;
    color: #293039;
    text-align: left;
}

.item--details--title a {
    text-decoration: none;
    font-size: 22px;
    line-height: 36px;
    font-weight: bold;
    color: #293039;
    text-align: left;
}

.item--details--meta {
    text-align: left;
    font-size: 14px;
    line-height: 27px;
    margin-bottom: 25px;
    color: #94a1ac;
}

.item--details--excerpt {
    text-align: left;
    font-size: 16px;
    line-height: 30px;
    font-weight: normal;
    color: #4e5c66;
}
</style>